
/*
 *  Constants and types.
 */

#ifndef __DEFS_H_
#define __DEFS_H_


/* Names for named resources allocated
   globally */
#define DRV_NAME "Opto Driver Version 1.0"


/* Prefix names for named resources allocated
   per device. */
#define DRV_NODE_TYPE "opto"


/*  Internal error codes  */
#define DRV_SUCCESS 0
#define DRV_FAILURE (-1)


/*  Types  */
typedef unsigned char byte_t;
typedef uint16_t word_t;

/*  Please use these macros everywhere to reference
    the high-order byte and the low-order byte in a word.  */
#define LOBYTE(_w)        (byte_t)(_w)
#define HIBYTE(_w)        (byte_t)((_w) >> 8)
#define MAKEWORD(_l,_h)   (word_t)(((_h) << 8) | (_l))


#endif /* __DEFS_H_ */

