
/*
 * Ring Buffer
 *
 */

#ifndef __RBUFFER_H_
#define __RBUFFER_H_

#ifndef __DEFS_H_
#error Include defs.h before including this file
#endif

/*  Default size of the ring buffer  */
#define RBUF_DEF_SIZE 512


/*  Ring Buffer ADT  */
struct rbuffer
{
	int capacity;
	int stored;
  
	byte_t* begin;
	byte_t* end;
	byte_t* writep;
	byte_t* readp;
  
	int (*construct)(struct rbuffer* rb, size_t size);
	void (*destruct)(struct rbuffer* rb);
	int (*read)(struct rbuffer* rb, byte_t* val, int count);
	void (*store)(struct rbuffer* rb, byte_t val);
};
typedef struct rbuffer rbuffer_t;


/*  Functions for creation and destruction of
    rbuffer instances.  */
rbuffer_t* rbuffer_create(void);
void rbuffer_destroy(rbuffer_t* rb);


#endif /* __RBUFFER_H_ */






























































